require 'flashboy/version'
require 'faraday'
require 'json'
require 'logger'

require 'ext/hash'

module Flashboy
  autoload :Ask,       'flashboy/ask'
  autoload :Bid,       'flashboy/bid'
  autoload :Client,    'flashboy/client'
  autoload :Exchange,  'flashboy/exchange'
  autoload :Order,     'flashboy/order'
  autoload :OrderBook, 'flashboy/order_book'
  autoload :Quote,     'flashboy/quote'
  autoload :Trade,     'flashboy/trade'

  autoload :Bitfinex,  'flashboy/bitfinex'
  autoload :Bittrex,   'flashboy/bittrex'
  autoload :Cex,       'flashboy/cex'
  autoload :Gdax,      'flashboy/gdax'
  autoload :Gemini,    'flashboy/gemini'
  autoload :Kraken,    'flashboy/kraken'
  autoload :Poloniex,  'flashboy/poloniex'
  autoload :Quoine,    'flashboy/quoine'

  def self.logger
    @logger ||= Logger.new(STDOUT)
  end

  def self.quote(pair)
    exchanges.map do |exchange|
      exchange.new.quote(pair)
    end
  end

  def self.order_book(pair)
    exchanges.map do |exchange|
      exchange.new.order_book(pair)
    end
  end

  def self.exchanges
    [Bitfinex, Bittrex, Cex, Gdax, Gemini, Kraken, Poloniex, Quoine]
  end
end
