module Flashboy
  class Client
    def self.name(name = nil)
      return @name if name.nil?
      @name = name
    end

    def name
      self.class.name
    end

    def self.key
      @name.to_s.downcase.gsub(' ', '_').to_sym
    end

    def key
      self.class.key
    end

    def self.docs(docs = nil)
      return @docs if docs.nil?
      @docs = docs
    end

    def docs
      self.class.docs
    end

    def self.host(host = nil)
      return @host if host.nil?
      @host = host
    end

    def host
      self.class.host
    end

    def self.quote_path(pair = nil, &path)
      return @quote_path.call(pair) unless block_given?
      @quote_path = path
    end

    def quote_path(pair)
      self.class.quote_path(pair)
    end

    def self.trades_path(pair = nil, params = {}, &path)
      if !block_given?
        raise RuntimeError, "You must define the trades_path on your exchange" if @trades_path.nil?
        return @trades_path.call(pair, params)
      end

      @trades_path = path
    end

    def trades_path(pair, params = {})
      self.class.trades_path(pair, params)
    end

    def self.order_book_path(pair = nil, &path)
      return @order_book_path.call(pair) unless block_given?
      @order_book_path = path
    end

    def order_book_path(pair)
      self.class.order_book_path(pair)
    end
  end
end
