module Flashboy
  class Trade
    attr_reader :global_id, :type, :exchange, :pair, :price, :amount, :executed_at

    def initialize(attrs)
      @global_id = attrs[:global_id]
      @type = attrs[:type]
      @exchange = attrs[:exchange]
      @pair = attrs[:pair]
      @price = attrs[:price].to_s.to_f
      @amount = attrs[:amount].to_s.to_f
      @executed_at = attrs[:executed_at]
    end

    def id
      global_id.split('-').last
    end

    def to_json(_opts)
      {
        global_id: global_id,
        type: type,
        exchange: exchange,
        pair: pair,
        price: price,
        amount: amount,
        executed_at: executed_at
      }.to_json
    end
  end
end
